#!/bin/bash

TOPDIR="$(dirname $0)/../../"

lfwdir="$(ls -d $TOPDIR/build_*/w-linux-firmware-*/fake-*/root/lib/firmware | head -n 1)"
[[ -d $lfwdir ]] || {
	echo "firmware directory '$lfwdir' does not exist - run 'make package' first?"
	exit 1
}

(
echo '1,/### SUBPKG INSERT POINT ###/-1p' | ed $TOPDIR/package/linux-firmware/Makefile.tmpl
#subpkgs=""
first_iter=true
files="$(cd $lfwdir; find . -type f)"
for path in $files; do
	fname="${path#./}"
	fname="$(tr '/.-' '_' <<< $fname)"
	fname_upper="$(tr 'a-z' 'A-Z' <<< $fname)"

	if $first_iter; then
		echo 'PKG_SUBPKGS:= LXFW_'$fname_upper
		first_iter=false
	else
		echo 'PKG_SUBPKGS+= LXFW_'$fname_upper
	fi
	echo 'PKGSD_LXFW_'$fname_upper':= '${path#./}
	echo 'lxfw-obj-${LXFW_'$fname_upper'}+='$fname'-install'
	echo $fname'-install: '${path#./}
	echo -e '\t${INSTALL_DIR} ${IDIR_LXFW_'$fname_upper'}/lib/firmware'
	echo -e '\t${INSTALL_DATA} $^ ${IDIR_LXFW_'$fname_upper'}/lib/firmware/$^'
	echo '$(eval $(call PKG_template,LXFW_'$fname_upper','$fname',${PKG_VERSION}-${PKG_RELEASE},${PKG_DEPENDS},'$fname',${PKG_SECTION}))'
done

#echo 'PKG_SUBPKGS:='$subpkgs
echo '/### SUBPKG INSERT POINT ###/+1,$p' | ed $TOPDIR/package/linux-firmware/Makefile.tmpl
) >$TOPDIR/package/linux-firmware/Makefile
